﻿using System;
using System.Windows.Input;

namespace EventLogAnalyzer.Common
{
    public class RelayCommand : ICommand
    {
        private Action<object> _execute;
        private Predicate<object> _canexecute;

        public RelayCommand(Action<object> execute) : this(execute, null){}
        
        public RelayCommand(Action<object> execute, Predicate<object> canExecute)
        {
            if (execute == null)
                throw new ArgumentException("execute");

            _execute = execute;
            _canexecute = canExecute;
        }

        public void Execute(object parameter)
        {
            _execute(parameter);
        }

        public bool CanExecute(object parameter)
        {
            return _canexecute == null || _canexecute(parameter);
        }

        public event EventHandler CanExecuteChanged
        {
            add { CommandManager.RequerySuggested += value;}
            remove { CommandManager.RequerySuggested -= value;}
        }
    }
}