﻿using System;
using System.ComponentModel;

namespace EventLogAnalyzer.ViewModel
{
    public class ViewModelBase : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        protected void OnPropertyChanged(string propertyName)
        {
            VerifyPropertyName(propertyName);

            if(PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        private void VerifyPropertyName(string propertyName)
        {
            if(TypeDescriptor.GetProperties(this)[propertyName] == null)
            {
                throw new Exception("Property not found " + propertyName);
            }
        }

        public bool IsValidProperty(string propertyName)
        {
            return TypeDescriptor.GetProperties(this)[propertyName] != null;
        }
    }
}
